unit umisc;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils; 
  
// Prozedurtypen fr Fortschrittsanzeige,Abbruch und Meldung
type TSetProgressInfo = procedure(Progress:Integer) of object; stdcall;
type TSetBool          = procedure(var ABool:Boolean) of object; stdcall;
type TMesssageOut     = procedure(M:String) of object; stdcall;

function LittleEndian:Boolean;
procedure TurnWord(var S:LongWord);
procedure CopyStringToStream(const s:String; const st:TStream);
procedure CopyStreamToString(const st:TStream; var s: String);
function StringToHex(s:String) : String;

implementation

function LittleEndian:Boolean;
//prft die Reihenfolge der Bytes eines Wortes im Speicher
var b:Byte; w:Word;
begin
  b := 1;
  w := 0;
  Move(b,w,1);
  Result := (w=1);
end;

procedure TurnWord(var S:LongWord);
//dreht die Byte-Reihenfolge in einem 32Bit-Wort
var b: Array[0..3] of Byte;
begin
  b[0] := 0; b[0] := S AND $FF; S := S shr 8;
  b[1] := 0; b[1] := S AND $FF; S := S shr 8;
  b[2] := 0; b[2] := S AND $FF; S := S shr 8;
  b[3] := 0; b[3] := S AND $FF;
  S := 0;
  S := S OR b[0]; S := S shl 8;
  S := S OR b[1]; S := S shl 8;
  S := S OR b[2]; S := S shl 8;
  S := S OR b[3];
end;

function TurnInt64(const S:Int64):Int64;
//dreht die Byte-Reihenfolge in einem Int64 Datum um
var w: Array[0..1] of LongWord;
begin
  Result := S;
  w[0] := 0; w[0] := Result AND $FFFFFFFF; TurnWord(w[0]); Result := Result shr 32;
  w[1] := 0; w[1] := Result AND $FFFFFFFF; TurnWord(w[1]);
  Result  := 0;  Result := Result OR w[0]; Result := Result shl 32; Result := Result OR w[1];
end;

procedure CopyStringToStream(const s:String; const st:TStream);
begin
  if Length(s)>0 then
    begin
      st.Seek(0,soFromBeginning);
      st.Write(s[1],Length(s));
    end;
end;

procedure CopyStreamToString(const st:TStream; var s: String);
begin
  SetLength(s,0);
  if st.Size < High(Integer) then
    begin
      SetLength(s,st.Size);
      st.Seek(0,soFromBeginning);
      st.Read(s[1],Length(s));
    end;
end;

function StringToHex(s:String) : String;
var i : integer;
begin
  Result := '';
  i:=1;
  while i <= Length(s) do
    begin
      Result := Result + IntToHex(ord(s[i]),2);
      Inc(i);
    end;
end;


end.

